<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>4.4 Examples</title>
<link href="sx4c.html" rev=precedes>
<link href="sx5.html" rel=precedes>
<link href="sx4.html" rev=subdocument>
</head>
<body>
<H2>4.4 Examples</H2>

<p>Here is an example demonstrating
almost

everything we've seen so far:
<pre>
	int globalvar = 1;
	extern int anotherglobalvar;
	static int privatevar;

	f()
	{
		int localvar;
		int localvar2 = 2;
		static int persistentvar;
	}
</pre>
</p><p>Here we have six variables, three declared outside and three
declared inside of the function <TT>f()</TT>.
</p><p><TT>globalvar</TT> is a global variable.
The declaration we see is its defining instance
(it happens also to include an initial value).
<TT>globalvar</TT> can be used anywhere in this source file,
and it could be used in other source files, too
(as long as corresponding external declarations are issued in
those other source files).
</p><p><TT>anotherglobalvar</TT> is a second global variable.
It is <em>not</em> defined here;
the defining instance for it
(and its initialization)
is
somewhere else.
</p><p><TT>privatevar</TT> is a ``private'' global variable.
It can be used anywhere within this source file,
but functions in other source files cannot access it,
even if they try to issue external declarations for it.
(If other source files try to declare

a global variable called
``<TT>privatevar</TT>'', they'll get their own;
they won't be sharing this one.)
Since it has static duration and receives no explicit initialization,
<TT>privatevar</TT> will be initialized to 0.
</p><p><TT>localvar</TT> is a local variable
within the function <TT>f()</TT>.
It can be accessed only within the function <TT>f()</TT>.
(If any other part of the program declares a variable named
``<TT>localvar</TT>'',
that variable will be distinct from the one we're looking at here.)
<TT>localvar</TT> is conceptually ``created'' each
time <TT>f()</TT> is called, and disappears
when <TT>f()</TT> returns.
Any value which was stored in <TT>localvar</TT> last time
<TT>f()</TT> was running will be lost and will not be
available next time <TT>f()</TT> is called.
Furthermore,
since it has no explicit initializer,
the value of <TT>localvar</TT> will in general be garbage
each time <TT>f()</TT> is called.
</p><p><TT>localvar2</TT> is also local,
and everything that we said about <TT>localvar</TT> applies to it,
except that since its declaration includes an explicit initializer,
it will be initialized to 2
each time <TT>f()</TT> is called.
</p><p>Finally, <TT>persistentvar</TT> is again local to <TT>f()</TT>,
but it <em>does</em> maintain its value between calls to <TT>f()</TT>.
It has static duration but no explicit initializer,
so its initial value will be 0.
</p><p>The defining instances and external declarations we've been
looking at so far have all been of simple variables.
There are also defining instances and external declarations of
functions, which we'll be looking at in the next chapter.
</p><p>(Also, don't worry about static variables for now
if they don't make sense to you;
they're a relatively sophisticated concept,
which you won't need to use at first.)
</p><p>The term <dfn>declaration</dfn> is a general one which
encompasses defining instances and external declarations;
defining instances and external declarations are two different
kinds of declarations.
Furthermore, either kind of declaration suffices to inform the
compiler of the name and type of a particular variable (or function).
If you have the defining instance of a global variable in a
source file, the rest of that source file can use that variable
without having to issue any external declarations.
It's only in source files where the defining instance hasn't
been seen that you need external declarations.
</p><p>You will sometimes hear a defining instance referred to simply
as a ``definition,''
and
you will sometimes hear an external declaration referred to simply
as a ``declaration.''
These usages are mildly ambiguous, in that you can't tell out
of context whether a ``declaration'' is a generic
declaration
(that might be a defining instance or an external declaration)
or whether it's an external declaration that specifically is
not a defining instance.
(Similarly, there are other constructions that can be called
``definitions'' in C, namely the definitions of
preprocessor macros, structures, and typedefs, none of which
we've met.)
In these notes, we'll try to make things clear by using the
unambiguous terms <dfn>defining instance</dfn>
and <dfn>external declaration</dfn>.
Elsewhere,

you may have to look at the context to determine how
the terms ``definition'' and
``declaration'' are being used.
</p><hr>
<p>
Read sequentially:
<a href="sx4c.html" rev=precedes>prev</a>
<a href="sx5.html" rel=precedes>next</a>
<a href="sx4.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-1997
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
